]> ruderich.org/simon Gitweb - config/dotfiles.git/blobdiff - x11/xinitrc
Move to x11/ in preparation for merge into new dotfiles repository
[config/dotfiles.git] / x11 / xinitrc
diff --git a/x11/xinitrc b/x11/xinitrc
new file mode 100755 (executable)
index 0000000..480fbc6
--- /dev/null
@@ -0,0 +1,192 @@
+#!/bin/sh
+
+# startx configuration file.
+
+# Copyright (C) 2011-2014  Simon Ruderich
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+
+# Some systems don't set the LANG environment variable when starting xinitrc,
+# this causes problems for rxvt-unicode-256color which fails to display UTF-8
+# characters correctly when LANG is missing and for notify.py which also needs
+# LANG set (for Python's decode() function). Therefore load my general shell
+# environment which also includes $LANG.
+if test -f "$HOME/.shell/env"; then
+    . "$HOME/.shell/env"
+fi
+
+
+installed() {
+    type "$1" >/dev/null 2>&1
+}
+error() {
+    if installed xmessage; then
+        xmessage "$@" &
+    else
+        # Log message to a file which is displayed by my Zsh setup on startup.
+        printf '%s\n' "$*" >>"$HOME/.xinitrc.errors"
+    fi
+}
+# Save PID of the most recently started background process. Used to terminate
+# them when logging out to prevent unused background processes. On some
+# systems this is only necessary for some programs (like ssh-agent), haven't
+# yet figured out why.
+save_background_pid() {
+    background_pids="$background_pids $!"
+}
+background_pids=
+
+
+# Options, can be modified in ~/.xinitrc.local. To disable a boolean option
+# set it to an empty value.
+#
+# Default to use a background image.
+set_background=yes
+# Default to display a warning if no screen locker is not available.
+screen_lock_force=yes
+# Lock screen after x minutes of inactivity.
+screen_lock_time=3
+# Locker program to lock the screen (with xautolock).
+screen_locker=xtrlock
+
+# Load settings for the local system.
+if test -f "$HOME/.xinitrc.local"; then
+    . "$HOME/.xinitrc.local"
+fi
+
+
+# Start ssh-agent if no agent is running, thanks to
+# http://code.haskell.org/XMonadContrib/scripts/xinitrc (read on 2011-06-19).
+if test -z "$SSH_AGENT_PID" && test -x /usr/bin/ssh-agent; then
+    # -s to force bourne shell output. This file is a bourne shell script even
+    # if the environment might suggest otherwise.
+    eval `/usr/bin/ssh-agent -s` >/dev/null
+fi
+
+# Use a black background for the root window.
+xsetroot -solid black
+
+# Force English keyboard layout.
+if installed setxkbmap; then
+    setxkbmap -option compose:menu us
+fi
+
+# Use the Caps lock as Ctrl because it's easier to reach and very useful for
+# all programs. Caps lock is removed completely. Thanks to
+# http://snarfed.org/space/switch%20control%20and%20caps%20lock
+if xmodmap | grep -E '^lock.*Caps_Lock' >/dev/null; then
+    xmodmap -e 'remove Lock = Caps_Lock'
+    xmodmap -e 'remove Control = Control_L'
+    xmodmap -e 'keysym Caps_Lock = Control_L'
+    xmodmap -e 'add Control = Control_L'
+fi
+# Move grave and tilde next to left shift key. This setting may only be
+# necessary because of my German keyboard which I use with an English layout.
+xmodmap -e 'keycode 94 = grave asciitilde'
+
+# Enable scrolling with trackpoint and middle mouse on Thinkpads, also disable
+# touchpad. Thanks to DerRoteBaron.
+if xinput 2>/dev/null | grep 'TPPS/2 IBM TrackPoint' >/dev/null; then
+    xinput set-int-prop "TPPS/2 IBM TrackPoint" "Evdev Wheel Emulation" 8 1
+    xinput set-int-prop "TPPS/2 IBM TrackPoint" "Evdev Wheel Emulation Button" 8 2
+    xinput set-int-prop "TPPS/2 IBM TrackPoint" "Evdev Wheel Emulation Axes" 8 6 7 4 5
+    xinput --disable "SynPS/2 Synaptics TouchPad"
+fi
+
+# Disable annoying audio bell. Thanks to Sebastian Rachuj.
+xset b off
+
+# Load settings for X programs. Xdefaults is deprecated.
+xrdb "$HOME/.Xresources"
+
+# Change the background if available.
+if test -f "$HOME/.background" && test -n "$set_background"; then
+    if installed hsetroot; then
+        hsetroot -full "$HOME/.background"
+    elif installed feh; then
+        feh --bg-scale "$HOME/.background"
+        # Remove the unnecessary ~/.fehbg file created by `feh`. I don't want
+        # to restore the background, I just run `feh` on each startx run.
+        # --no-fehbg is only available in recent feh releases.
+        rm -f "$HOME/.fehbg"
+    fi
+fi
+
+# Display timed reminders and recheck the file for changes every minute (-z1).
+if installed remind && test -f "$HOME/.reminders"; then
+    remind -z1 -k'.shell/bin/notify.py %s &' "$HOME/.reminders" &
+    save_background_pid
+fi
+
+# Set color temperature of display according to time of day.
+if installed redshift; then
+    redshift -l 49.9:10.9 -t 5500:4500 >/dev/null &
+fi
+
+
+# Start best available screen locker.
+xlockscreen=`"$HOME/.xlockscreen" start "$screen_lock_time" "$screen_locker"`
+if test $? -ne 0 && test -n "$screen_lock_force"; then
+    error "$xlockscreen"
+fi
+
+
+# Use compton to get transparent windows. See ~/.Xresources for configuration
+# of urxvt.
+if installed compton; then
+    compton &
+# xcompmgr as fallback.
+elif installed xcompmgr; then
+    xcompmgr &
+fi
+
+
+# My window manager doesn't start a terminal emulator on its own, start one
+# when I login.
+(urxvt || rxvt || xterm) &
+
+# Start window manager.
+failed=
+if installed herbstluftwm; then
+    herbstluftwm --locked || failed=1
+elif installed xmonad; then
+    xmonad || failed=1
+elif installed stumpwm; then
+    stumpwm || failed=1
+else
+    failed='no window manager found'
+fi
+# Fallback in case my window manager failed to start. Otherwise X terminates
+# the session immediately (because xinitrc finishes).
+if test -n "$failed"; then
+    if test x"$failed" = x1; then
+        failed='failed to start window manager'
+    fi
+    error "$failed (spawning fallback terminal)"
+    urxvt || rxvt || xterm
+fi
+
+
+# Cleanup.
+#
+# Kill ssh-agent to prevent unused background processes.
+if test -x /usr/bin/ssh-agent; then
+    /usr/bin/ssh-agent -k >/dev/null
+    # No `eval` necessary, we terminate anyway.
+fi
+# Kill remaining background processes.
+if test -n "$background_pids"; then
+    kill $background_pids
+fi